/***************************************************************************** 
 * Project: RooFit                                                           * 
 *                                                                           * 
 * This code was autogenerated by RooClassFactory                            * 
 *****************************************************************************/ 

    // Your description goes here... 


#include <math.h> 
#include "RooqqZZ_JHU_ZgammaZZ_fast.h"
#include "Riostream.h" 
#include "RooAbsReal.h" 
#include "RooAbsCategory.h" 
#include "TMath.h" 

//ClassImp(RooqqZZ_JHU_ZgammaZZ_fast) 

RooqqZZ_JHU_ZgammaZZ_fast::RooqqZZ_JHU_ZgammaZZ_fast(const char *name, const char *title, 
                                       RooAbsReal& _m1j,
                                       RooAbsReal& _m2j,
                                       RooAbsReal& _h1j,
                                       RooAbsReal& _h2j,
                                       RooAbsReal& _phij,
                                       RooAbsReal& _hsj,
                                       RooAbsReal& _Phi1j,
                                       RooAbsReal& _mZZj,
                                       RooAbsReal& _upFrac) :
RooAbsPdf(name,title), 
m1j("m1j","m1j",this,_m1j),
m2j("m2j","m2j",this,_m2j),
h1j("h1j","h1j",this,_h1j),
h2j("h2j","h2j",this,_h2j),
phij("phij","phij",this,_phij),
hsj("hsj","hsj",this,_hsj),
Phi1j("Phi1j","Phi1j",this,_Phi1j),
mZZj("mZZj","mZZj",this,_mZZj),
upFrac("upFrac","upFrac",this,_upFrac)
{ 
} 


RooqqZZ_JHU_ZgammaZZ_fast::RooqqZZ_JHU_ZgammaZZ_fast(const RooqqZZ_JHU_ZgammaZZ_fast& other, const char* name) :  
RooAbsPdf(other,name), 
m1j("m1j",this,other.m1j),
m2j("m2j",this,other.m2j),
h1j("h1j",this,other.h1j),
h2j("h2j",this,other.h2j),
phij("phij",this,other.phij),
hsj("hsj",this,other.hsj),
Phi1j("Phi1j",this,other.Phi1j),
mZZj("mZZj",this,other.mZZj),
upFrac("upFrac",this,other.upFrac)
{ 
} 



Double_t RooqqZZ_JHU_ZgammaZZ_fast::evaluate() const{
  // Do transformation of the angles from JHU to NW conventions...
  const double GeV=1./100.;

  if ((m1j+m2j) > mZZj || m2j>m1j) return 1e-40;

  double mZZ_c = mZZj*GeV;
  double m1_c = m1j*GeV;
  double m2_c = m2j*GeV;
  double h1_c = h1j;
  double h2_c = h2j;
  double phi_c = phij;
  double hs_c = hsj;
  double Phi1_c = Phi1j;

  // ENTER EXPRESSION IN TERMS OF VARIABLE ARGUMENTS HERE 
  double up_plusZ = partonicXS(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
  double up_minusZ = partonicXS(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
  double down_plusZ = partonicXS(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
  double down_minusZ = partonicXS(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);

  //std::cout << "up_plusZ = " << up_plusZ << ", up_minusZ = " << up_minusZ << ", down_plusZ = " << down_plusZ << ", down_minusZ = " << down_minusZ << std::endl;

  double upfrac = upFrac;
  double downfrac = 1-upFrac;

  //up_minusZ = 0; down_minusZ = 0;

  double totval = upfrac*(up_plusZ + up_minusZ) + downfrac*(down_plusZ + down_minusZ);

  //    double jacobian = 1./(mZZj);
  //    double jacobian = 4.*m1j*m2j;
  //    double jacobian = 1.;
  //    return jacobian*totval ; 
  return totval;
}


Int_t RooqqZZ_JHU_ZgammaZZ_fast::getAnalyticalIntegral(RooArgSet& allVars, RooArgSet& analVars, const char* /*rangeName*/) const{
  if (matchArgs(allVars, analVars, h1j, h2j, phij, Phi1j)) return 5;
  if (matchArgs(allVars, analVars, h2j, phij, Phi1j)) return 1;
  if (matchArgs(allVars, analVars, h1j, phij, Phi1j)) return 2;
  if (matchArgs(allVars, analVars, h1j, h2j, phij)) return 3;
  if (matchArgs(allVars, analVars, h1j, h2j, Phi1j)) return 4;
  return 0;
}
Double_t RooqqZZ_JHU_ZgammaZZ_fast::analyticalIntegral(Int_t code, const char* rangeName) const{
  const double GeV=1./100.;

  if ((m1j+m2j) > mZZj || m2j>m1j) return 1e-40;

  double mZZ_c = mZZj*GeV;
  double m1_c = m1j*GeV;
  double m2_c = m2j*GeV;
  double h1_c = h1j;
  double h2_c = h2j;
  double phi_c = phij;
  double hs_c = hsj;
  double Phi1_c = Phi1j;

  double upfrac = upFrac;
  double downfrac = 1-upFrac;
  //double jacobian = 1./mZZ_c;
  double jacobian = 4.*m1_c*m2_c;

  double up_plusZ=0;
  double up_minusZ=0;
  double down_plusZ=0;
  double down_minusZ=0;

  switch (code){
  case 1: {
            up_plusZ = integratePartonicXS_Dh2DphDPh1_1(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            up_minusZ = integratePartonicXS_Dh2DphDPh1_1(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            down_plusZ = integratePartonicXS_Dh2DphDPh1_1(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            down_minusZ = integratePartonicXS_Dh2DphDPh1_1(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            break;
  }
  case 2: {
            up_plusZ = integratePartonicXS_Dh1DphDPh1_2(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            up_minusZ = integratePartonicXS_Dh1DphDPh1_2(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            down_plusZ = integratePartonicXS_Dh1DphDPh1_2(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            down_minusZ = integratePartonicXS_Dh1DphDPh1_2(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            break;
  }
  case 3: {
            up_plusZ = integratePartonicXS_Dh1Dh2Dph_3(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            up_minusZ = integratePartonicXS_Dh1Dh2Dph_3(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            down_plusZ = integratePartonicXS_Dh1Dh2Dph_3(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            down_minusZ = integratePartonicXS_Dh1Dh2Dph_3(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            break;
  }
  case 4: {
            up_plusZ = integratePartonicXS_Dh1Dh2DPh1_4(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            up_minusZ = integratePartonicXS_Dh1Dh2DPh1_4(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            down_plusZ = integratePartonicXS_Dh1Dh2DPh1_4(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            down_minusZ = integratePartonicXS_Dh1Dh2DPh1_4(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            break;
  }
  case 5: {
            up_plusZ = integratePartonicXS_Dh1Dh2DphDPh1_5(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            up_minusZ = integratePartonicXS_Dh1Dh2DphDPh1_5(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            down_plusZ = integratePartonicXS_Dh1Dh2DphDPh1_5(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            down_minusZ = integratePartonicXS_Dh1Dh2DphDPh1_5(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            break;
  }
  default: {
             assert(0);
             return 0;
  }
  }
  double totval = upfrac*(up_plusZ + up_minusZ) + downfrac*(down_plusZ + down_minusZ);
  return jacobian*totval;
}
    //*/
    // 45 terms
Double_t RooqqZZ_JHU_ZgammaZZ_fast::partonicXS(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool isuubar, bool flipAxis) const{
  const double GeV=1./100.;

  // define hs, h1, h2, phi1, phi2 for the NW angular conventions
  double s = mZZ_c*mZZ_c;
  double M1 = m1_c;
  double M2 = m2_c;
  double hs = hs_c;
  double h1 = h1_c;
  double h2 = h2_c;
  double phi = phi_c;
  double Phi1 = Phi1_c;

  // extra definitions needed
  //    double shs = Sqrt(1-hs*hs); // sin Theta
  //    double sh1 = Sqrt(1-h1*h1); // sin theta1
  //    double sh2 = Sqrt(1-h2*h2); // sin theta2
  //    double hsdb = 1 - 2*shs*shs; // cos 2*Theta
  //    double shsdb = 2*hs*shs; // sin 2*Theta
  //    double h1db = 1 - 2*sh1*sh1; // cos 2*theta1
  //    double h2db = 1 - 2*sh2*sh2; // cos 2*theta2

  // definitions ------------------
  double theta1 = acos(h1);
  double theta2 = acos(h2);
  double Theta = acos(hs);

  if (flipAxis){
    //        hs *= -1.;
    Theta += TMath::Pi();
    Phi1 += TMath::Pi();
    //phi += 0;
  }


  double x = (M1*M1-M2*M2)/s;
  double beta1 = sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x)));
  double beta2 = sqrt(1. - (4.*M2*M2)/(s*(1-x)*(1-x)));
  double MZ = 91.1876*GeV; // mass of the Z
  double wZ = 2.4952*GeV; // width of the Z
  double xW = 0.23119; // sin2thetaW
  double Pi = TMath::Pi();
  double alpha = 1./128.; // EM constant

  double gamma1 = 1./sqrt(1 - beta1*beta1);
  double gamma2 = 1./sqrt(1 - beta2*beta2);

  // fix to remove compiler warnings
  if (gamma1||gamma2){}

  double EE = sqrt(4.*Pi*alpha);
  double el = -EE;
  double eq = (-1./3.)*EE;

  double Tf3 = -1/2.; double Qf = -1.;
  double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
  // conversion   
  gL = gL * sqrt(Pi*alpha/(xW*(1-xW)));
  gR = gR * sqrt(Pi*alpha/(xW*(1-xW)));

  double qTf3, qQf;
  if (isuubar){
    qTf3 = 1/2.; qQf = 2./3.;
  }
  else{
    qTf3 = -1/2.; qQf = -1./3.;
  }
  double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
  gqL = gqL * sqrt(Pi*alpha/(xW*(1-xW)));
  gqR = gqR * sqrt(Pi*alpha/(xW*(1-xW)));
  // end definitions ------------------


  //    std::cout << "Ms = " << M1 << ", " << M2 << ", " << Sqrt(s) << std::endl;
  //    std::cout << "x = " << x << std::endl;    
  //    std::cout << "betas = " << beta1 << ", " << beta2 << std::endl;
  //    std::cout << "gammas = " << gamma1 << ", " << gamma2 << std::endl;

  // ----
  double totval = 0.;


  double gqL4= gqL*gqL*gqL*gqL;
  double gqR4= gqR*gqR*gqR*gqR;
  double gqL3= gqL*gqL*gqL;
  double gqR3= gqR*gqR*gqR;
  double M22 = M2*M2;
  //double M23 = M2*M2*M2;
  double M24 = M2*M2*M2*M2;
  //double M26 = M2*M2*M2*M2*M2*M2;
  //double M28 = M2*M2*M2*M2*M2*M2*M2*M2;
  double M12 = M1*M1;
  //double M13 = M1*M1*M1;
  double M14 = M1*M1*M1*M1;
  //double M16 = M1*M1*M1*M1*M1*M1;
  //double M18 = M1*M1*M1*M1*M1*M1*M1*M1;
  double MZ2 = MZ*MZ;
  double MZ4 = MZ*MZ*MZ*MZ;
  double wZ2 = wZ*wZ;

  double sqrts = TMath::Power(s, 0.5);
  //double s2 = s*s;
  //double s3 = s*s*s;
  double sminus2 = 1./(s*s);
  double sminus1 = 1./s;

  //double Piminus4 = 1./(Pi*Pi*Pi*Pi);
  //double Piminus6 = 1./(Pi*Pi*Pi*Pi*Pi*Pi);

  double costheta  = cos(Theta);
  double sintheta  = sin(Theta);

  //double costhetaP2 = costheta*costheta;
  //double costhetaP4 = costheta*costheta*costheta*costheta;
  //double sinthetaP2 = sintheta*sintheta;
  //double sinthetaP4 = sintheta*sintheta*sintheta*sintheta;

  double costheta1 = cos(theta1);
  double costheta2 = cos(theta2);
  double sintheta1 = sin(theta1);
  double sintheta2 = sin(theta2);

  double cosphi1   = cos(Phi1);
  double cosphiplusphi1 = cos(phi + Phi1);

  double sminusm22P2 = (-s + M22)*(-s + M22);
  double m22minusmz2P2 = (M22 - MZ2)*(M22 - MZ2);
  double m12minusmz2P2 = (M12 - MZ2)*(M12 - MZ2);
  double sqrtm14m12sm22smm22=TMath::Power(M14 -2*M12*(s + M22) + sminusm22P2, 0.5);

  double oneminuscosthetacostheta1 = (-1 + costheta*costheta1);
  double oneminuscosthetacostheta2 = (-1 + costheta*costheta2);
  double onepluscosthetacostheta1 = (1 + costheta*costheta1);
  //double onepluscosthetacostheta2 = (1 + costheta*costheta2);

  double gR2 = gR*gR;
  double gL2 = gL*gL;

  totval += (TMath::Power(Pi, -7)*sminus1*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*(-8*TMath::Power(M1, -4)*TMath::Power(M2, -4)*(2*el*eq*(gL + gR)*(gqL3 + gqR3)*(gL2 + gR2)*M12*M22*(2*M12*M22 -(M12 + M22)*MZ2) +2*TMath::Power(el, 2)*TMath::Power(eq, 2)*(TMath::Power(gqL, 2) + TMath::Power(gqR, 2))*(2*gL*gR*M12*M22*((M1 - MZ)*(M2 - MZ)*(M1 + MZ)*(M2 + MZ) +MZ2*wZ2) +gL2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 +MZ4 + MZ2*wZ2)) +gR2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 +MZ4 + MZ2*wZ2))) +(gqL4 + gqR4)*M14*M24*TMath::Power(gL2 + gR2, 2))*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 - costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), -2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. + (oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 - costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), -2)*((M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/1024. + (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/1024. - (TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/1024. + (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/1024. - (TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. +(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. +(TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 - costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. +(TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. +(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M22*TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(M22*TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 - costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(M12*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(M12*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(M12*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(M12*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 - costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +(M12*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(M12*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -(TMath::Power(s - M12 - M22 +costheta2*sqrtm14m12sm22smm22 + costheta1*(-(costheta2*(-s + M12 + M22)) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. -(s*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/16.)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/64. -(TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 + costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. -(s*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/16.)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/64. +(s*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. + ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.))/4. + (M12*M22*((oneminuscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/4. + (s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. -2*((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4.))/2. +((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 + costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(-(TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1))/256. - (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +(TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. -(TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*((M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1))/16. -((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. + ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. +(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*((M12*M22)/4. +TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)/64. + ((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/32. -((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(-((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22/2. +(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/4.))/8. -(M12*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. +((oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/8. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4.))/8.))/8.))/8. +((s - M12 - M22 +costheta2*sqrtm14m12sm22smm22 +costheta1*(-(costheta2*(-s + M12 + M22)) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(-(TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1))/256. - (TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. - (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. + (TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. + (M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*((M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1))/16. +((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. - ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. +(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*((M12*M22)/4. +TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)/64. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/32. -((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. -((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/8.))/2. + ((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(-((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22/2. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/4.))/8. +((s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/8. -M12*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)) +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4.))/8.))/8.))/8.) +8*TMath::Power(M1, -2)*TMath::Power(M2, -4)*((gqL4 - gqR4)*(TMath::Power(gL, 4) - TMath::Power(gR, 4))*M12*M24 +2*el*eq*(gL - gR)*(gqL3 - gqR3)*M22*(2*(gL*gR + gL2 + gR2)*M12*M22 -(TMath::Power(gL + gR, 2)*M12 +(gL2 + gR2)*M22)*MZ2) +2*(gqL - gqR)*(gqL + gqR)*(gL - gR)*(gL + gR)*TMath::Power(el, 2)*TMath::Power(eq, 2)*((-M2 + MZ)*(M2 + MZ)*(-2*M12*M22 + (M12 + M22)*MZ2) + (M12 + M22)*MZ2*wZ2))*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 - costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), -2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. + (oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 - costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), -2)*((M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/1024. + (TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/1024. + (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. -(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. -(TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 - costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. -(TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. -(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M22*TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(M22*TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 - costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +(TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +(M12*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(M12*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +(M12*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(M12*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 - costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -(TMath::Power(s - M12 - M22 +costheta2*sqrtm14m12sm22smm22 + costheta1*(-(costheta2*(-s + M12 + M22)) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. -(s*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/16.)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/64. -(TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 + costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. -(s*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/16.)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/64. -(s*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*((M12*M22*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/4. + (-(onepluscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/4. + (s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/4. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. +((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.))/4.))/2. + ((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 + costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(-(TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1))/256. - (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +(TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. +(TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. -(TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*((M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1))/16. -((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. + ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. +(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*((M12*M22)/4. -TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)/64. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/32. +((s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*((-(oneminuscosthetacostheta2*(-s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/4. +(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/4. +(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/8.))/2. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(-((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22/2. +(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/4.))/8. -(M12*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. +((oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/8. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4.))/8.))/8.))/8. +((s - M12 - M22 +costheta2*sqrtm14m12sm22smm22 +costheta1*(-(costheta2*(-s + M12 + M22)) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(-(TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1))/256. + (TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. - (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. + (TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. - (TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*((M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1))/16. +((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. - ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. -(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(-(M12*M22)/4. +((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/4. +(-s + M12 + M22 -costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/8. + ((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/8. + ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(-s + M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/4.))/2. + ((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(-((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22/2. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/4.))/8. +((s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/8. -M12*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)) +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4.))/8.))/8.))/8.) -8*TMath::Power(M1, -4)*TMath::Power(M2, -2)*((gqL4 - gqR4)*(TMath::Power(gL, 4) - TMath::Power(gR, 4))*M14*M22 +2*el*eq*(gL - gR)*(gqL3 - gqR3)*M12*(2*(gL*gR + gL2 + gR2)*M12*M22 -((gL2 + gR2)*M12 +TMath::Power(gL + gR, 2)*M22)*MZ2) +2*(gqL - gqR)*(gqL + gqR)*(gL - gR)*(gL + gR)*TMath::Power(el, 2)*TMath::Power(eq, 2)*((-M1 + MZ)*(M1 + MZ)*(-2*M12*M22 + (M12 + M22)*MZ2) + (M12 + M22)*MZ2*wZ2))*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 - costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), -2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. + (oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 - costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), -2)*(-(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 - costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/1024. + (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/1024. + (TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. +(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. +(TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 - costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. -(TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. -(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(M12*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(M12*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 - costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -(M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 - 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. +(TMath::Power(s - M12 - M22 +costheta2*sqrtm14m12sm22smm22 + costheta1*(-(costheta2*(-s + M12 + M22)) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. -(s*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/16.)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/64. -(TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 + costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. -(s*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/16.)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/64. +(s*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*((M12*M22*((-(oneminuscosthetacostheta2*(-s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/4. +(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/4. +(-s + M12 + M22 -costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/4. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. +((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.))/4.))/2. + ((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 + costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*((TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1))/256. - (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +(TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. -(TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. -(TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*((M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1))/16. -((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. + ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. -(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(-(M12*M22)/4. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/32. +((s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*((-(onepluscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/4. +(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/8.))/2. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*((M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.)))/16. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/32. +((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. -(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/8. -((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. -(M12*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/32.))/8.))/8. +((s - M12 - M22 +costheta2*sqrtm14m12sm22smm22 +costheta1*(-(costheta2*(-s + M12 + M22)) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(-(TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1))/256. + (TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. + (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. - (TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. + (TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*((M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1))/16. +((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. - ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. +(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(-(M12*M22)/4. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/32. +((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*((-(onepluscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/4. +(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/8. + ((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*((s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(-s + M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/8.))/2. + ((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(-(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.)))/16. +((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s + (oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))/8. +((s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(-((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/8. +M12*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)) -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 + M22 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.) -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4.))/8.))/8.))/8.) +8*TMath::Power(gL - gR, 2)*TMath::Power(M1, -2)*TMath::Power(M2, -2)*((gqL4 + gqR4)*TMath::Power(gL + gR, 2)*M12*M22 +2*el*eq*(gL + gR)*(gqL3 + gqR3)*(2*M12*M22 - (M12 + M22)*MZ2) +2*TMath::Power(el, 2)*TMath::Power(eq, 2)*(TMath::Power(gqL, 2) + TMath::Power(gqR, 2))*((M1 - MZ)*(M2 - MZ)*(M1 + MZ)*(M2 + MZ) + MZ2*wZ2))*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 + costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 + 2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), -2)*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. + (oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), -2)*(-(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M22*TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M12*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M12*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M22*TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M22*TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. + (M12*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (M12*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/512. - (TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. -(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. -(TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. +(TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M12*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. +(TMath::Power(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/512. +(TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/2048. -(TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. + (TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. - (TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 + 2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. + (TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 - costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. + (M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. - (TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 + costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. - (M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. + (M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. - ((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. - (TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. - ((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. - (M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. - (M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. + (TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 + 2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. + (M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. + (TMath::Power(-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 - 2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. + ((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. + (M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. + ((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/2048. - (M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/1024. - ((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. + ((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. - ((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. + ((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4096. + (TMath::Power(s - M12 - M22 +costheta2*sqrtm14m12sm22smm22 + costheta1*(-(costheta2*(-s + M12 + M22)) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. -(s*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/16.)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/64. - (TMath::Power(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 + costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)*(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. -(s*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/16.)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/64. + (s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. + (onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(-((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. +((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.))/4. + (M12*M22*((s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(-s + M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/4.))/2. + ((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*((TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1))/256. - (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. + (TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. + (TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. + (TMath::Power(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +(TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*((M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1))/16. -((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. + ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*((M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.)))/16. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/32. +((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. -(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/8. -((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. -(M12*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/32.))/8. +(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*((M12*M22)/4. +TMath::Power(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2, 2)/64. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/32. +((s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. -2*((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8.))/2.))/8. +((s - M12 - M22 +costheta2*sqrtm14m12sm22smm22 +costheta1*(-(costheta2*(-s + M12 + M22)) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(-(TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1))/256. - (TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*TMath::Power(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.), 2)*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. + (M22*TMath::Power(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/64. - (TMath::Power(M12 - 2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.), 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2))/256. - (TMath::Power(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2, 2)*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -(TMath::Power(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1, 2)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. -(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/256. +(M12*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(M22 - 2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/128. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/512. +((onepluscosthetacostheta1*(s + M12 - M22) +costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*((M22*(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1))/16. +((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2))/64. -((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/64.)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8. -(s*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*((M12*M22)/4. +((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)*((-s + M12 + M22 -costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/8. + ((oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(-s + M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8.))/4. + ((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*((s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. +(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2)/8. -2*((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/8.))/2. +((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))*(-(M22*(-(oneminuscosthetacostheta1*(s + M12 - M22)) +costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.)))/16. +((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 -costheta2*sqrtm14m12sm22smm22 -costheta1*(costheta2*(-s + M12 + M22) +sqrtm14m12sm22smm22) -2*M1*M2*cos(phi)*sintheta1*sintheta2)*(s + (oneminuscosthetacostheta2*(-s + M12 - M22) -costheta*sqrtm14m12sm22smm22 +costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.))/8. +((s - M12 + M22 +costheta*(costheta2*(s - M12 + M22) -sqrtm14m12sm22smm22) -costheta2*sqrtm14m12sm22smm22 -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)*(-((M12 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.))*(s - M12 - M22 +costheta1*(costheta2*(-s + M12 + M22) -sqrtm14m12sm22smm22) +costheta2*sqrtm14m12sm22smm22 +2*M1*M2*cos(phi)*sintheta1*sintheta2))/8. +M12*(M22 -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)) -((onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)*(M12 + M22 -2*((-(oneminuscosthetacostheta1*(s + M12 - M22)) -costheta*sqrtm14m12sm22smm22 +costheta1*sqrtm14m12sm22smm22 -2*M1*cosphi1*sqrts*sintheta*sintheta1)/8. +(onepluscosthetacostheta1*(s + M12 - M22) -costheta*sqrtm14m12sm22smm22 -costheta1*sqrtm14m12sm22smm22 +2*M1*cosphi1*sqrts*sintheta*sintheta1)/8.) -2*((s - M12 + M22 +costheta2*sqrtm14m12sm22smm22 +costheta*(costheta2*(s - M12 + M22) +sqrtm14m12sm22smm22) -2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8. +(oneminuscosthetacostheta2*(-s + M12 - M22) +costheta*sqrtm14m12sm22smm22 -costheta2*sqrtm14m12sm22smm22 +2*M2*cosphiplusphi1*sqrts*sintheta*sintheta2)/8.)))/4.))/8.))/8.))/8.)))/393216.;



  //    double returnVal = 0.; 
  //    for (int i = 0; i < nterms; i++){
  //        //std::cout << "term[" << i << "] = " << term[i] << std::endl;
  //        if (term[i] != term[i]) { 
  //            std::cout << "isNaN" << std::endl; 
  //            term[i] = 0.; 
  //        }
  //        returnVal += term[i];
  //    }

  if ((totval <= 0)||(totval != totval)) totval = 1.e-40;

  //    std::cout << "returnVal = " << totval << std::endl;

  return totval;
}

Double_t RooqqZZ_JHU_ZgammaZZ_fast::integratePartonicXS_Dh2DphDPh1_1(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool isuubar, bool flipAxis) const{
  const double GeV=1./100.;

  // define hs, h1, h2, phi1, phi2 for the NW angular conventions
  double s = mZZ_c*mZZ_c;
  double M1 = m1_c;
  double M2 = m2_c;
  double hs = hs_c;
  double h1 = h1_c;
  double h2 = h2_c;
  double phi = phi_c;
  double Phi1 = Phi1_c;

  // fix to remove compiler warnings
  if (phi){}

  // extra definitions needed
  //    double shs = Sqrt(1-hs*hs); // sin Theta
  //    double sh1 = Sqrt(1-h1*h1); // sin theta1
  //    double sh2 = Sqrt(1-h2*h2); // sin theta2
  //    double hsdb = 1 - 2*shs*shs; // cos 2*Theta
  //    double shsdb = 2*hs*shs; // sin 2*Theta
  //    double h1db = 1 - 2*sh1*sh1; // cos 2*theta1
  //    double h2db = 1 - 2*sh2*sh2; // cos 2*theta2

  // definitions ------------------
  double theta1 = acos(h1);
  double theta2 = acos(h2);
  double Theta = acos(hs);

  // fix to remove compiler warnings
  if (theta2){}

  if (flipAxis){
    //        hs *= -1.;
    Theta += TMath::Pi();
    Phi1 += TMath::Pi();
    //phi += 0;
  }

  double x = (M1*M1-M2*M2)/s;
  double beta1 = sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x)));
  double beta2 = sqrt(1. - (4.*M2*M2)/(s*(1-x)*(1-x)));
  double MZ = 91.1876*GeV; // mass of the Z
  double wZ = 2.4952*GeV; // width of the Z
  double xW = 0.23119; // sin2thetaW
  double Pi = TMath::Pi();
  double alpha = 1./128.; // EM constant

  double gamma1 = 1./sqrt(1 - beta1*beta1);
  double gamma2 = 1./sqrt(1 - beta2*beta2);

  // fix to remove compiler warnings
  if (gamma1||gamma2){}

  double EE = sqrt(4.*Pi*alpha);
  double el = -EE;
  double eq = (-1./3.)*EE;

  double Tf3 = -1/2.; double Qf = -1.;
  double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
  // conversion   
  gL = gL * sqrt(Pi*alpha/(xW*(1-xW)));
  gR = gR * sqrt(Pi*alpha/(xW*(1-xW)));

  double qTf3, qQf;
  if (isuubar){
    qTf3 = 1/2.; qQf = 2./3.;
  }
  else{
    qTf3 = -1/2.; qQf = -1./3.;
  }
  double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
  gqL = gqL * sqrt(Pi*alpha/(xW*(1-xW)));
  gqR = gqR * sqrt(Pi*alpha/(xW*(1-xW)));

  // end definitions ------------------

  // ----
  double totval = 0.;
  double gqL4= gqL*gqL*gqL*gqL;
  double gqR4= gqR*gqR*gqR*gqR;
  double gqL3= gqL*gqL*gqL;
  double gqR3= gqR*gqR*gqR;
  double M22 = M2*M2;
  //double M23 = M2*M2*M2;
  double M24 = M2*M2*M2*M2;
  double M26 = M2*M2*M2*M2*M2*M2;
  double M28 = M2*M2*M2*M2*M2*M2*M2*M2;
  double M12 = M1*M1;
  //double M13 = M1*M1*M1;
  double M14 = M1*M1*M1*M1;
  double M16 = M1*M1*M1*M1*M1*M1;
  double M18 = M1*M1*M1*M1*M1*M1*M1*M1;
  double MZ2 = MZ*MZ;
  double MZ4 = MZ*MZ*MZ*MZ;
  double wZ2 = wZ*wZ;

  //double sqrts = TMath::Power(s,0.5);
  double s2 = s*s;
  double s3 = s*s*s;
  double sminus2 = 1./(s*s);
  double sminus1 = 1./s;

  //double Piminus4 = 1./(Pi*Pi*Pi*Pi);
  //double Piminus6 = 1./(Pi*Pi*Pi*Pi*Pi*Pi);

  double costheta  = cos(Theta);
  double sintheta  = sin(Theta);

  double costhetaP2 = costheta*costheta;
  double costhetaP4 = costheta*costheta*costheta*costheta;
  double sinthetaP2 = sintheta*sintheta;
  //double sinthetaP4 = sintheta*sintheta*sintheta*sintheta;

  double costheta1 = cos(theta1);
  //double costheta2 = cos(theta2);
  double sintheta1 = sin(theta1);
  //double sintheta2 = sin(theta2);

  //double cosphi1   = cos(Phi1);
  //double cosphiplusphi1 = cos(phi + Phi1);

  double sminusm22P2 = (-s + M22)*(-s + M22);
  double m22minusmz2P2 = (M22 - MZ2)*(M22 - MZ2);
  double m12minusmz2P2 = (M12 - MZ2)*(M12 - MZ2);
  //double sqrtm14m12sm22smm22=TMath::Power(M14 -2*M12*(s + M22) + sminusm22P2,0.5);

  //double oneminuscosthetacostheta1 = (-1 + costheta*costheta1);
  //double oneminuscosthetacostheta2 = (-1 + costheta*costheta2);
  //double onepluscosthetacostheta1 = (1 + costheta*costheta1);
  //double onepluscosthetacostheta2 = (1 + costheta*costheta2);

  double gR2 = gR*gR;
  double gL2 = gL*gL;

  totval += -((gqL - gqR)*(gqL + gqR)*(gL - gR)*(gL + gR)*costheta*costheta1*TMath::Power(el, 2)*TMath::Power(eq, 2)*TMath::Power(M2, -2)*TMath::Power(Pi, -5)*sminus1*(-((M2 - MZ)*(M2 + MZ)*(-2*M12*M22 +(M12 + M22)*MZ2)) +(M12 + M22)*MZ2*wZ2)*(-M18 + 2*M16*(s + M22) -2*s*M14*(s + 7*M22) +cos(2*Theta)*(-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(M14 - M24 + s2) +(s + M22)*TMath::Power(-s + M22, 3) -2*M12*(-s + M22)*TMath::Power(s + M22, 2))*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/18432. +(el*eq*(gL - gR)*costheta*costheta1*(gqL3 - gqR3)*(2*(gL*gR + gL2 + gR2)*M12*M22 -(TMath::Power(gL + gR, 2)*M12 + (gL2 + gR2)*M22)*MZ2)*TMath::Power(Pi, -5)*sminus1*(M18 - 2*M16*(s + M22) +2*s*M14*(s + 7*M22) -cos(2*Theta)*(-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(M14 - M24 + s2) -(s + M22)*TMath::Power(-s + M22, 3) +2*M12*(-s + M22)*TMath::Power(s + M22, 2))*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/18432. -(TMath::Power(el, 2)*TMath::Power(eq, 2)*(TMath::Power(gqL, 2) + TMath::Power(gqR, 2))*TMath::Power(M1, -2)*TMath::Power(M2, -2)*TMath::Power(Pi, -5)*sminus1*(2*gL*gR*M12*M22*((M1 - MZ)*(M2 - MZ)*(M1 + MZ)*(M2 + MZ) + MZ2*wZ2) +gL2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 + MZ4 +MZ2*wZ2)) +gR2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 + MZ4 +MZ2*wZ2)))*(-15*M18 + 6*M16*(3*s + 2*M22) +M14*(-280*s*M22 + 6*M24 - 6*s2) +2*M12*(-115*s*M24 + 6*M26 +36*M22*s2 + 9*s3) -3*(6*s*M22 + 5*M24 + 5*s2)*sminusm22P2 +cos(2*theta1)*(-5*M18 + M16*(22*s + 4*M22) +2*M14*(-20*s*M22 + M24 - 17*s2) +2*M12*(55*s*M24 + 2*M26 -4*M22*s2 + 11*s3) -(6*s*M22 + 5*M24 + 5*s2)*sminusm22P2) + cos(4*Theta)*(M14 - 2*M12*(s + M22) +sminusm22P2)*(3*M14 - 2*M12*(2*s + 3*M22) +3*sminusm22P2 +cos(2*theta1)*(M14 - 2*M12*(-2*s + M22) +sminusm22P2)) +4*cos(2*Theta)*(-2*s*M16 + 3*M18 -2*M14*(14*s*M22 + 3*M24 + s2) -2*s*M12*(10*s*M22 + 5*M24 + s2) +cos(2*theta1)*(-6*s*M16 + M18 + M28 -2*M14*(10*s*M22 + M24 - 5*s2) +2*s*M12*(2*s*M22 + 17*M24 - 3*s2) -2*M24*s2 + TMath::Power(s, 4)) +3*TMath::Power(M24 - s2, 2)))*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/589824. +(el*eq*(gL + gR)*(gqL3 + gqR3)*(gL2 + gR2)*(-2*M12*M22 + (M12 + M22)*MZ2)*TMath::Power(Pi, -5)*sminus1*(-15*M18 +6*M16*(3*s + 2*M22) +M14*(-280*s*M22 + 6*M24 - 6*s2) +2*M12*(-115*s*M24 + 6*M26 +36*M22*s2 + 9*s3) -3*(6*s*M22 + 5*M24 + 5*s2)*sminusm22P2 +cos(2*theta1)*(-5*M18 + M16*(22*s + 4*M22) +2*M14*(-20*s*M22 + M24 - 17*s2) +2*M12*(55*s*M24 + 2*M26 -4*M22*s2 + 11*s3) -(6*s*M22 + 5*M24 + 5*s2)*sminusm22P2) + cos(4*Theta)*(M14 - 2*M12*(s + M22) +sminusm22P2)*(3*M14 - 2*M12*(2*s + 3*M22) +3*sminusm22P2 +cos(2*theta1)*(M14 - 2*M12*(-2*s + M22) +sminusm22P2)) +4*cos(2*Theta)*(-2*s*M16 + 3*M18 -2*M14*(14*s*M22 + 3*M24 + s2) -2*s*M12*(10*s*M22 + 5*M24 + s2) +3*TMath::Power(M24 - s2, 2) +cos(2*theta1)*(-6*s*M16 + M18 -2*M14*(10*s*M22 + M24 - 5*s2) +2*s*M12*(2*s*M22 + 17*M24 - 3*s2) +TMath::Power(M24 - s2, 2))))*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/589824. -(costheta*costheta1*(gqL4 - gqR4)*(TMath::Power(gL, 4) - TMath::Power(gR, 4))*M12*M22*TMath::Power(Pi, -5)*sminus1*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(costhetaP2*(M18 - 2*s*M14*M22 -M16*(s + 2*M22) +M12*(-s + M22)*(s + M22)*(s + 2*M22) -(s + M22)*TMath::Power(-s + M22, 3)) -(-s + M12 + M22)*(s*M22*(3*M12 + M22) + M22*s2 -s3 + TMath::Power(M12 - M22, 3) +s*M12*(s - M12 + M22)*sinthetaP2)))/18432. - ((gqL4 + gqR4)*TMath::Power(Pi, -5)*sminus1*TMath::Power(gL2 + gR2, 2)*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(4*M12*M22*costhetaP4*(TMath::Power(costheta1, 2)*(3*M18 - 12*M16*M22 +6*M14*(-s + M22)*(s + 3*M22) +4*M12*M22*(6*s*M22 - 3*M24 + s2) +3*TMath::Power(-s + M22, 4)) +(-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*TMath::Power(s - M12 + M22, 2) +TMath::Power(M14 - 2*M12*(s + M22) +sminusm22P2, 2)*TMath::Power(sintheta1, 2)) -TMath::Power(-s + M12 + M22, 2)*(M22*(4*M12*(3*(s + TMath::Power(M1 - M2, 2))*(s + TMath::Power(M1 + M2, 2)) +TMath::Power(costheta1, 2)*(M14 - 2*M12*(s + M22) +sminusm22P2) +4*s*(-M12 + M22)*sinthetaP2) +s*(M14 - 2*M12*(s + M22) +sminusm22P2)*TMath::Power(sin(2*Theta), 2)) +M12*(-4*M22*(M14 - 2*M12*(s + M22) +sminusm22P2 +2*s*sinthetaP2*(-s - 2*M12 + 4*M22 + s*sinthetaP2)) +s*(M14 - 4*s*M22 - 2*M12*(s + M22) +M24 + s2)*TMath::Power(sin(2*Theta), 2))*TMath::Power(sintheta1, 2)) -4*costhetaP2*(-2*M12*M22*(M18 + 2*M16*(s + M22) + M28 -2*M24*s2 -2*M14*(4*s*M22 + 3*M24 + 3*s2) +2*M12*(-9*s*M24 + M26 -5*M22*s2 + s3) + TMath::Power(s, 4)) +2*M12*M22*TMath::Power(costheta1, 2)*(M18 + 2*M16*(s - 3*M22) +2*M14*(6*s*M22 + 5*M24 - 3*s2) -2*M12*(9*s*M24 + 3*M26 +M22*s2 - s3) + TMath::Power(-s + M22, 4) -2*s*M12*TMath::Power(s - M12 + M22, 2)*sinthetaP2) +(-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(s*M22*(M14 - 2*M12*(s + M22) +sminusm22P2)*sinthetaP2 +M12*(2*M22*(-2*s*M12 + M14 + sminusm22P2) +s*(M14 - 2*s*(M12 + 2*M22) +3*M24 + s2)*sinthetaP2)*TMath::Power(sintheta1, 2))) +4*s*costheta*(-s + TMath::Power(M1 - M2, 2))*(-s + M12 + M22)*(-s + TMath::Power(M1 + M2, 2))*(M22*(-s + M12 + M22) +M12*(-s + M12 + 2*M22)*TMath::Power(sintheta1, 2))*sintheta*sin(2*Theta)))/589824.;



  if ((totval <= 0)||(totval != totval)) totval = 1.e-40;

  //    std::cout << "returnVal_1 = " << totval << std::endl;
  //    totval*=(1./sh1);

  return totval;
}

Double_t RooqqZZ_JHU_ZgammaZZ_fast::integratePartonicXS_Dh1DphDPh1_2(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool isuubar, bool flipAxis) const{
  const double GeV=1./100.;

  // define hs, h1, h2, phi1, phi2 for the NW angular conventions
  double s = mZZ_c*mZZ_c;
  double M1 = m1_c;
  double M2 = m2_c;
  double hs = hs_c;
  double h1 = h1_c;
  double h2 = h2_c;
  double phi = phi_c;
  double Phi1 = Phi1_c;

  // fix to remove compiler warnings
  if (phi){}

  // extra definitions needed
  //    double shs = Sqrt(1-hs*hs); // sin Theta
  //    double sh1 = Sqrt(1-h1*h1); // sin theta1
  //    double sh2 = Sqrt(1-h2*h2); // sin theta2
  //    double hsdb = 1 - 2*shs*shs; // cos 2*Theta
  //    double shsdb = 2*hs*shs; // sin 2*Theta
  //    double h1db = 1 - 2*sh1*sh1; // cos 2*theta1
  //    double h2db = 1 - 2*sh2*sh2; // cos 2*theta2

  // definitions ------------------
  double theta1 = acos(h1);
  double theta2 = acos(h2);
  double Theta = acos(hs);

  // fix to remove compiler warnings
  if (theta1){}

  if (flipAxis){
    //        hs *= -1.;
    Theta += TMath::Pi();
    Phi1 += TMath::Pi();
    //phi += 0;
  }

  double x = (M1*M1-M2*M2)/s;
  double beta1 = sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x)));
  double beta2 = sqrt(1. - (4.*M2*M2)/(s*(1-x)*(1-x)));
  double MZ = 91.1876*GeV; // mass of the Z
  double wZ = 2.4952*GeV; // width of the Z
  double xW = 0.23119; // sin2thetaW
  double Pi = TMath::Pi();
  double alpha = 1./128.; // EM constant

  double gamma1 = 1./sqrt(1 - beta1*beta1);
  double gamma2 = 1./sqrt(1 - beta2*beta2);

  // fix to remove compiler warnings
  if (gamma1 || gamma2){}

  double EE = sqrt(4.*Pi*alpha);
  double el = -EE;
  double eq = (-1./3.)*EE;

  double Tf3 = -1/2.; double Qf = -1.;
  double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
  // conversion   
  gL = gL * sqrt(Pi*alpha/(xW*(1-xW)));
  gR = gR * sqrt(Pi*alpha/(xW*(1-xW)));

  double qTf3, qQf;
  if (isuubar){
    qTf3 = 1/2.; qQf = 2./3.;
  }
  else{
    qTf3 = -1/2.; qQf = -1./3.;
  }
  double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
  gqL = gqL * sqrt(Pi*alpha/(xW*(1-xW)));
  gqR = gqR * sqrt(Pi*alpha/(xW*(1-xW)));

  // end definitions ------------------

  double totval = 0.;
  double gqL4= gqL*gqL*gqL*gqL;
  double gqR4= gqR*gqR*gqR*gqR;
  double gqL3= gqL*gqL*gqL;
  double gqR3= gqR*gqR*gqR;
  double M22 = M2*M2;
  //double M23 = M2*M2*M2;
  double M24 = M2*M2*M2*M2;
  double M26 = M2*M2*M2*M2*M2*M2;
  double M28 = M2*M2*M2*M2*M2*M2*M2*M2;
  double M12 = M1*M1;
  double M13 = M1*M1*M1;
  double M14 = M1*M1*M1*M1;
  double M16 = M1*M1*M1*M1*M1*M1;
  double M18 = M1*M1*M1*M1*M1*M1*M1*M1;
  double MZ2 = MZ*MZ;
  double MZ4 = MZ*MZ*MZ*MZ;
  double wZ2 = wZ*wZ;

  //double sqrts = TMath::Power(s,0.5);
  double s2 = s*s;
  double s3 = s*s*s;
  double sminus2 = 1./(s*s);
  double sminus1 = 1./s;

  //double Piminus4 = 1./(Pi*Pi*Pi*Pi);
  //double Piminus6 = 1./(Pi*Pi*Pi*Pi*Pi*Pi);

  double costheta  = cos(Theta);
  double sintheta  = sin(Theta);

  double costhetaP2 = costheta*costheta;
  double costhetaP4 = costheta*costheta*costheta*costheta;
  double sinthetaP2 = sintheta*sintheta;
  //double sinthetaP4 = sintheta*sintheta*sintheta*sintheta;

  //double costheta1 = cos(theta1);
  double costheta2 = cos(theta2);
  //double sintheta1 = sin(theta1);
  double sintheta2 = sin(theta2);

  //double cosphi1   = cos(Phi1);
  //double cosphiplusphi1 = cos(phi + Phi1);

  double sminusm22P2 = (-s + M22)*(-s + M22);
  double m22minusmz2P2 = (M22 - MZ2)*(M22 - MZ2);
  double m12minusmz2P2 = (M12 - MZ2)*(M12 - MZ2);
  //double sqrtm14m12sm22smm22=TMath::Power(M14 -2*M12*(s + M22) + sminusm22P2,0.5);

  //double oneminuscosthetacostheta1 = (-1 + costheta*costheta1);
  //double oneminuscosthetacostheta2 = (-1 + costheta*costheta2);
  //double onepluscosthetacostheta1 = (1 + costheta*costheta1);
  //double onepluscosthetacostheta2 = (1 + costheta*costheta2);

  double gR2 = gR*gR;
  double gL2 = gL*gL;

  totval += -(TMath::Power(el, 2)*TMath::Power(eq, 2)*(TMath::Power(gqL, 2) + TMath::Power(gqR, 2))*TMath::Power(M1, -2)*TMath::Power(M2, -2)*TMath::Power(Pi, -5)*sminus1*(2*gL*gR*M12*M22*(M12*(M22 - MZ2) +MZ2*(-M22 + MZ2 + wZ2)) +gL2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 + MZ4 +MZ2*wZ2)) +gR2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 + MZ4 +MZ2*wZ2)))*(12*s*M16 + 4*s*cos(2*theta2)*M16 - 15*M18 -5*cos(2*theta2)*M18 - 230*s*M14*M22 +110*s*cos(2*theta2)*M14*M22 + 12*M16*M22 +4*cos(2*theta2)*M16*M22 - 280*s*M12*M24 -40*s*cos(2*theta2)*M12*M24 + 6*M14*M24 +2*cos(2*theta2)*M14*M24 + 18*s*M26 +22*s*cos(2*theta2)*M26 + 12*M12*M26 +4*cos(2*theta2)*M12*M26 - 15*M28 -5*cos(2*theta2)*M28 + 6*M14*s2 +2*cos(2*theta2)*M14*s2 +72*M12*M22*s2 -8*cos(2*theta2)*M12*M22*s2 -6*M24*s2 - 34*cos(2*theta2)*M24*s2 +12*M12*s3 + 4*cos(2*theta2)*M12*s3 +18*M22*s3 + 22*cos(2*theta2)*M22*s3 -15*TMath::Power(s, 4) - 5*cos(2*theta2)*TMath::Power(s, 4) +cos(4*Theta)*(3*M14 - 4*s*M22 -6*M12*(s + M22) + 3*M24 + 3*s2 +cos(2*theta2)*(M14 + 4*s*M22 -2*M12*(s + M22) + M24 + s2))*(M14 - 2*M12*(s + M22) + sminusm22P2) + 4*cos(2*Theta)*(3*M18 -4*s*M12*M22*(5*s + 7*M22) -2*M14*(5*s*M22 + 3*M24 + 3*s2) +(4*s*M22 + 3*M24 + 3*s2)*sminusm22P2 +cos(2*theta2)*(M18 +4*s*M12*(s - 5*M22)*M22 -2*M14*(-17*s*M22 + M24 + s2) +(-4*s*M22 + M24 + s2)*sminusm22P2)))*TMath::Power(M14 - 2*M12*MZ2 + MZ4 +MZ2*wZ2, -1)*TMath::Power(M24 - 2*M22*MZ2 + MZ4 +MZ2*wZ2, -1)*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2))/589824. - (el*eq*(gL - gR)*costheta*costheta2*(gqL3 - gqR3)*(2*(gL*gR + gL2 + gR2)*M12*M22 -((gL2 + gR2)*M12 + TMath::Power(gL + gR, 2)*M22)*MZ2)*TMath::Power(Pi, -5)*sminus1*(-M18 + 2*s*M14*M22 + 2*M16*(s + M22) +cos(2*Theta)*(-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(M14 - M24 - s2) -2*M12*(-7*s*M24 + M26 + M22*s2 +s3) + (M24 + s2)*sminusm22P2)*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/18432. -((gqL - gqR)*(gqL + gqR)*(gL - gR)*(gL + gR)*costheta*costheta2*TMath::Power(el, 2)*TMath::Power(eq, 2)*TMath::Power(M1, -2)*TMath::Power(Pi, -5)*sminus1*(-((M1 - MZ)*(M1 + MZ)*(-2*M12*M22 +(M12 + M22)*MZ2)) +(M12 + M22)*MZ2*wZ2)*(-M18 + 2*s*M14*M22 + 2*M16*(s + M22) +cos(2*Theta)*(-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(M14 - M24 - s2) -2*M12*(-7*s*M24 + M26 + M22*s2 +s3) + (M24 + s2)*sminusm22P2)*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/18432. +(el*eq*(gL + gR)*(gqL3 + gqR3)*(gL2 + gR2)*(-2*M12*M22 + (M12 + M22)*MZ2)*TMath::Power(Pi, -5)*sminus1*(2*s*(6*M16 - 115*M14*M22 -140*M12*M24 + 9*M26) +6*(M14 + 12*M12*M22 - M24)*s2 +6*(2*M12 + 3*M22)*s3 - 15*TMath::Power(s, 4) -3*(5*M14 + 6*M12*M22 + 5*M24)*TMath::Power(M12 - M22, 2) +cos(4*Theta)*(3*M14 - 4*s*M22 -6*M12*(s + M22) + 3*M24 + 3*s2 +cos(2*theta2)*(M14 + 4*s*M22 -2*M12*(s + M22) + M24 + s2))*(M14 - 2*M12*(s + M22) + sminusm22P2) + cos(2*theta2)*(-5*M18 + 4*M16*(s + M22) +2*M14*(55*s*M22 + M24 + s2) +4*M12*(-10*s*M24 + M26 -2*M22*s2 + s3) -(-12*s*M22 + 5*M24 + 5*s2)*sminusm22P2) +4*cos(2*Theta)*(3*M18 -4*s*M12*M22*(5*s + 7*M22) -2*M14*(5*s*M22 + 3*M24 + 3*s2) +(4*s*M22 + 3*M24 + 3*s2)*sminusm22P2 +cos(2*theta2)*(M18 +4*s*M12*(s - 5*M22)*M22 -2*M14*(-17*s*M22 + M24 + s2) +(-4*s*M22 + M24 + s2)*sminusm22P2)))*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/589824. -(costheta*costheta2*(gqL4 - gqR4)*(TMath::Power(gL, 4) - TMath::Power(gR, 4))*M12*M22*TMath::Power(Pi, -5)*sminus1*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(costhetaP2*(M18 - s*M14*M22 -2*M16*(s + M22) +2*M12*(s + M22)*(M24 + s2) -(s*M22 + M24 + s2)*sminusm22P2) -(-s + M12 + M22)*(-(s*M12*(M12 + 3*M22)) - M12*s2 +s3 + TMath::Power(M12 - M22, 3) +s*M22*(-s - M12 + M22)*sinthetaP2)))/18432. - ((gqL4 + gqR4)*TMath::Power(Pi, -5)*sminus1*TMath::Power(gL2 + gR2, 2)*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(4*M12*M22*costhetaP4*((-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*TMath::Power(s + M12 - M22, 2) +TMath::Power(costheta2, 2)*(2*(9*M14 + 2*M12*M22 - 3*M24)*s2 - 12*M12*s3 + 3*TMath::Power(s, 4) + 3*TMath::Power(M12 - M22, 4) -12*s*TMath::Power(M13 - M1*M22, 2)) +TMath::Power(M14 - 2*M12*(s + M22) +sminusm22P2, 2)*TMath::Power(sintheta2, 2)) -TMath::Power(-s + M12 + M22, 2)*(M12*(4*M22*(3*(s + TMath::Power(M1 - M2, 2))*(s + TMath::Power(M1 + M2, 2)) +TMath::Power(costheta2, 2)*(M14 - 2*M12*(s + M22) +sminusm22P2) +4*(M1 - M2)*(M1 + M2)*s*sinthetaP2) +s*(M14 - 2*M12*(s + M22) +sminusm22P2)*TMath::Power(sin(2*Theta), 2)) +M22*(-4*M12*(M14 - 2*M12*(s + M22) +sminusm22P2 +2*s*sinthetaP2*(-s + 4*M12 - 2*M22 + s*sinthetaP2)) +s*(M14 - 2*M12*(2*s + M22) +sminusm22P2)*TMath::Power(sin(2*Theta), 2))*TMath::Power(sintheta2, 2)) -4*costhetaP2*(-2*M12*M22*(M18 + 2*M16*M22 +2*M12*M22*(-5*s + M22)*(s + M22) -2*M14*(9*s*M22 + 3*M24 + s2) +(4*s*M22 + M24 + s2)*sminusm22P2) + 2*M12*M22*TMath::Power(costheta2, 2)*(M18 - 2*M16*(2*s + 3*M22) +2*M14*(-9*s*M22 + 5*M24 + 3*s2) -2*M12*(-6*s*M24 + 3*M26 +M22*s2 + 2*s3) +(4*s*M22 + M24 + s2)*sminusm22P2 -2*s*M22*TMath::Power(s + M12 - M22, 2)*sinthetaP2) +(-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(s*M12*(M14 - 2*M12*(s + M22) +sminusm22P2)*sinthetaP2 +M22*(2*M12*(-2*s*M12 + M14 + sminusm22P2) +s*(-4*s*M12 + 3*M14 + sminusm22P2)*sinthetaP2)*TMath::Power(sintheta2, 2))) +4*s*costheta*(-s + TMath::Power(M1 - M2, 2))*(-s + M12 + M22)*(-s + TMath::Power(M1 + M2, 2))*(M12*(-s + M12 + M22) +M22*(-s + 2*M12 + M22)*TMath::Power(sintheta2, 2))*sintheta*sin(2*Theta)))/589824.;



  if ((totval <= 0)||(totval != totval)) totval = 1.e-40;

  //    std::cout << "returnVal_2 = " << totval << std::endl;
  //    totval*=(1./sh2);

  return totval;
}

Double_t RooqqZZ_JHU_ZgammaZZ_fast::integratePartonicXS_Dh1Dh2Dph_3(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool isuubar, bool flipAxis) const{
  const double GeV=1./100.;

  // define hs, h1, h2, phi1, phi2 for the NW angular conventions
  double s = mZZ_c*mZZ_c;
  double M1 = m1_c;
  double M2 = m2_c;
  double hs = hs_c;
  double h1 = h1_c;
  double h2 = h2_c;
  double phi = phi_c;
  double Phi1 = Phi1_c;

  // fix to remove compiler warnings
  if (phi){}

  /*
   std::cout << "-----------" << std::endl;
   std::cout << "h1 = " << h1 << "; " << std::endl;
   std::cout << "h2 = " << h2 << "; " << std::endl;
   std::cout << "hs = " << hs << "; " << std::endl;
   std::cout << "phi = " << phi << "; " << std::endl;
   std::cout << "Phi1 = " << Phi1 << "; " << std::endl;
   //*/

  // extra definitions needed
  //    double shs = Sqrt(1-hs*hs); // sin Theta
  //    double sh1 = Sqrt(1-h1*h1); // sin theta1
  //    double sh2 = Sqrt(1-h2*h2); // sin theta2
  //    double hsdb = 1 - 2*shs*shs; // cos 2*Theta
  //    double shsdb = 2*hs*shs; // sin 2*Theta
  //    double h1db = 1 - 2*sh1*sh1; // cos 2*theta1
  //    double h2db = 1 - 2*sh2*sh2; // cos 2*theta2

  // definitions ------------------
  double theta1 = acos(h1);
  double theta2 = acos(h2);
  double Theta = acos(hs);

  // fix to remove compiler warnings
  if (theta1||theta2){}

  if (flipAxis){
    //        hs *= -1.;
    Theta += TMath::Pi();
    Phi1 += TMath::Pi();
    //phi += 0;
  }


  double x = (M1*M1-M2*M2)/s;
  double beta1 = sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x)));
  double beta2 = sqrt(1. - (4.*M2*M2)/(s*(1-x)*(1-x)));
  double MZ = 91.1876*GeV; // mass of the Z
  double wZ = 2.4952*GeV; // width of the Z
  double xW = 0.23119; // sin2thetaW
  double Pi = TMath::Pi();
  double alpha = 1./128.; // EM constant

  double gamma1 = 1./sqrt(1 - beta1*beta1);
  double gamma2 = 1./sqrt(1 - beta2*beta2);

  // fix to remove compiler warnings
  if (gamma1||gamma2){}

  double EE = sqrt(4.*Pi*alpha);
  double el = -EE;
  double eq = (-1./3.)*EE;

  double Tf3 = -1/2.; double Qf = -1.;
  double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
  // conversion   
  gL = gL * sqrt(Pi*alpha/(xW*(1-xW)));
  gR = gR * sqrt(Pi*alpha/(xW*(1-xW)));

  double qTf3, qQf;
  if (isuubar){
    qTf3 = 1/2.; qQf = 2./3.;
  }
  else{
    qTf3 = -1/2.; qQf = -1./3.;
  }
  double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
  gqL = gqL * sqrt(Pi*alpha/(xW*(1-xW)));
  gqR = gqR * sqrt(Pi*alpha/(xW*(1-xW)));

  // end definitions ------------------

  /*
   std::cout << "-----------" << std::endl;
   std::cout << "beta1 = " << beta1 << "; " << std::endl;
   std::cout << "beta2 = " << beta2 << "; " << std::endl;
   std::cout << "gL = " << gL << "; " << std::endl;
   std::cout << "gR = " << gR << "; " << std::endl;
   std::cout << "gqL = " << gqL << "; " << std::endl;
   std::cout << "gqR = " << gqR << "; " << std::endl;
   //*/

  double totval = 0.;
  double gqL4= gqL*gqL*gqL*gqL;
  double gqR4= gqR*gqR*gqR*gqR;
  double gqL3= gqL*gqL*gqL;
  double gqR3= gqR*gqR*gqR;
  double M22 = M2*M2;
  double M23 = M2*M2*M2;
  double M24 = M2*M2*M2*M2;
  double M26 = M2*M2*M2*M2*M2*M2;
  //double M28 = M2*M2*M2*M2*M2*M2*M2*M2;
  double M12 = M1*M1;
  //double M13 = M1*M1*M1;
  double M14 = M1*M1*M1*M1;
  double M16 = M1*M1*M1*M1*M1*M1;
  double M18 = M1*M1*M1*M1*M1*M1*M1*M1;
  double MZ2 = MZ*MZ;
  double MZ4 = MZ*MZ*MZ*MZ;
  double wZ2 = wZ*wZ;

  double sqrts = TMath::Power(s, 0.5);
  double s2 = s*s;
  double s3 = s*s*s;
  double sminus2 = 1./(s*s);
  double sminus1 = 1./s;

  //double Piminus4 = 1./(Pi*Pi*Pi*Pi);
  double Piminus6 = 1./(Pi*Pi*Pi*Pi*Pi*Pi);

  double costheta  = cos(Theta);
  double sintheta  = sin(Theta);

  double costhetaP2 = costheta*costheta;
  double costhetaP4 = costheta*costheta*costheta*costheta;
  double sinthetaP2 = sintheta*sintheta;
  //double sinthetaP4 = sintheta*sintheta*sintheta*sintheta;

  //double costheta1 = cos(theta1);
  //double costheta2 = cos(theta2);
  //double sintheta1 = sin(theta1);
  //double sintheta2 = sin(theta2);

  double cosphi1   = cos(Phi1);
  //double cosphiplusphi1 = cos(phi + Phi1);

  double sminusm22P2 = (-s + M22)*(-s + M22);
  double m22minusmz2P2 = (M22 - MZ2)*(M22 - MZ2);
  double m12minusmz2P2 = (M12 - MZ2)*(M12 - MZ2);
  double sqrtm14m12sm22smm22=TMath::Power(M14 -2*M12*(s + M22) + sminusm22P2, 0.5);

  //double oneminuscosthetacostheta1 = (-1 + costheta*costheta1);
  //double oneminuscosthetacostheta2 = (-1 + costheta*costheta2);
  //double onepluscosthetacostheta1 = (1 + costheta*costheta1);
  //double onepluscosthetacostheta2 = (1 + costheta*costheta2);

  double gR2 = gR*gR;
  double gL2 = gL*gL;


  totval += -(el*eq*(gL + gR)*(gqL3 + gqR3)*(gL2 + gR2)*TMath::Power(M1, -2)*(2*M12*M22 -(M12 + M22)*MZ2)*Piminus6*sminus1*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(8*M12*costhetaP4*(6*(M14 + M24)*s2 -5*(M12 + M22)*s3 + 2*TMath::Power(s, 4) -5*s*(M12 + M22)*TMath::Power(M12 - M22, 2) +2*TMath::Power(M12 - M22, 4)) +4*costhetaP2*(4*M12*(M12*(-3*s + M22)*(s + M22)*(-s + 4*M22) + M16*(3*s + 4*M22) -M14*(9*s*M22 + 8*M24 + 6*s2) +3*s*TMath::Power(-(M2*s) + M23, 2)) +s*((-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(3*M14 + M12*(-4*s + 8*M22) +sminusm22P2) +4*M12*TMath::Power(cosphi1, 2)*(2*M16 - M14*(3*s + 4*M22) +2*M12*(-(s*M22) + M24) +s*sminusm22P2))*sinthetaP2) -TMath::Power(-s + M12 + M22, 2)*(8*M12*(5*s*(M12 + M22) + 2*s2 +2*TMath::Power(M12 - M22, 2) +s*sinthetaP2*(-3*(M1 - M2)*(M1 + M2) +2*TMath::Power(cosphi1, 2)*(s + 2*M12 - 4*M22 - s*sinthetaP2))) +s*(M14 - 2*M12*(2*s + M22) +sminusm22P2)*TMath::Power(sin(2*Theta), 2))))/442368. -(TMath::Power(el, 2)*TMath::Power(eq, 2)*(TMath::Power(gqL, 2) + TMath::Power(gqR, 2))*TMath::Power(M1, -4)*TMath::Power(M2, -2)*Piminus6*sminus1*(2*gL*gR*M12*M22*((M1 - MZ)*(M2 - MZ)*(M1 + MZ)*(M2 + MZ) + MZ2*wZ2) +gL2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 + MZ4 +MZ2*wZ2)) +gR2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 + MZ4 +MZ2*wZ2)))*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(8*M12*costhetaP4*(6*(M14 + M24)*s2 -5*(M12 + M22)*s3 + 2*TMath::Power(s, 4) -5*s*(M12 + M22)*TMath::Power(M12 - M22, 2) +2*TMath::Power(M12 - M22, 4)) +4*costhetaP2*(4*M12*(M12*(-3*s + M22)*(s + M22)*(-s + 4*M22) + M16*(3*s + 4*M22) -M14*(9*s*M22 + 8*M24 + 6*s2) +3*s*TMath::Power(-(M2*s) + M23, 2)) +s*((-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(3*M14 + M12*(-4*s + 8*M22) +sminusm22P2) +4*M12*TMath::Power(cosphi1, 2)*(2*M16 - M14*(3*s + 4*M22) +2*M12*(-(s*M22) + M24) +s*sminusm22P2))*sinthetaP2) -TMath::Power(-s + M12 + M22, 2)*(8*M12*(5*s*(M12 + M22) + 2*s2 +2*TMath::Power(M12 - M22, 2) +s*sinthetaP2*(-3*(M1 - M2)*(M1 + M2) +2*TMath::Power(cosphi1, 2)*(s + 2*M12 - 4*M22 - s*sinthetaP2))) +s*(M14 - 2*M12*(2*s + M22) +sminusm22P2)*TMath::Power(sin(2*Theta), 2))))/442368. -((gqL4 + gqR4)*M22*Piminus6*sminus1*TMath::Power(gL2 + gR2, 2)*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(8*M12*costhetaP4*(6*(M14 + M24)*s2 -5*(M12 + M22)*s3 + 2*TMath::Power(s, 4) -5*s*(M12 + M22)*TMath::Power(M12 - M22, 2) +2*TMath::Power(M12 - M22, 4)) +4*costhetaP2*(4*M12*(M12*(-3*s + M22)*(s + M22)*(-s + 4*M22) + M16*(3*s + 4*M22) -M14*(9*s*M22 + 8*M24 + 6*s2) +3*s*TMath::Power(-(M2*s) + M23, 2)) +s*((-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(3*M14 + M12*(-4*s + 8*M22) +sminusm22P2) +4*M12*TMath::Power(cosphi1, 2)*(2*M16 - M14*(3*s + 4*M22) +2*M12*(-(s*M22) + M24) +s*sminusm22P2))*sinthetaP2) -TMath::Power(-s + M12 + M22, 2)*(8*M12*(5*s*(M12 + M22) + 2*s2 +2*TMath::Power(M12 - M22, 2) +s*sinthetaP2*(-3*(M1 - M2)*(M1 + M2) +2*TMath::Power(cosphi1, 2)*(s + 2*M12 - 4*M22 - s*sinthetaP2))) +s*(M14 - 2*M12*(2*s + M22) +sminusm22P2)*TMath::Power(sin(2*Theta), 2))))/884736. +((gqL - gqR)*(gqL + gqR)*(gL - gR)*(gL + gR)*cosphi1*TMath::Power(el, 2)*TMath::Power(eq, 2)*TMath::Power(M1, -1)*TMath::Power(M2, -4)*TMath::Power(Pi, -5)*sminus1*(-((M2 - MZ)*(M2 + MZ)*(-2*M12*M22 +(M12 + M22)*MZ2)) +(M12 + M22)*MZ2*wZ2)*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*(TMath::Power(M1, 10)*sqrts + 3*M18*(-s + M22)*sqrts +(-s + M22)*M24*(sqrts*sminusm22P2 -sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) -M16*((-3*s + 10*M22)*TMath::Power(s, 1.5) +sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) +M14*(sqrts*(18*s*M24 + 4*M26 +7*M22*s2 - s3) +s*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5) -3*M22*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) +M12*M22*(-9*M26*sqrts +14*M24*TMath::Power(s, 1.5) +2*s*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5) -M22*(5*TMath::Power(s, 2.5) +3*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5))) +cos(2*Theta)*(TMath::Power(M1, 10)*sqrts -M18*(3*s + M22)*sqrts +(-s + M22)*M24*(sqrts*sminusm22P2 -sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) -M16*(sqrts*(6*s*M22 + 4*M24 - 3*s2) +sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) +M14*(sqrts*(10*s*M24 + 8*M26 + 11*M22*s2 -s3) + s*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5) -3*M22*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) +M12*M22*(-5*M26*sqrts +2*M24*TMath::Power(s, 1.5) - 4*TMath::Power(s, 3.5) +2*s*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5) +M22*(7*TMath::Power(s, 2.5) -3*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)))))*TMath::Power(M14 + M12*(-2*s + 6*M22) +sminusm22P2 -cos(2*Theta)*(M14 - 2*M12*(s + M22) +sminusm22P2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*sintheta)/36864. + (el*eq*(gL - gR)*cosphi1*(gqL3 - gqR3)*TMath::Power(M1, -1)*TMath::Power(M2, -2)*(2*(gL*gR + gL2 + gR2)*M12*M22 -(TMath::Power(gL + gR, 2)*M12 + (gL2 + gR2)*M22)*MZ2)*TMath::Power(Pi, -5)*sminus1*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*(TMath::Power(M1, 10)*sqrts + 3*M18*(-s + M22)*sqrts +(-s + M22)*M24*(sqrts*sminusm22P2 -sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) -M16*((-3*s + 10*M22)*TMath::Power(s, 1.5) +sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) +M14*(sqrts*(18*s*M24 + 4*M26 +7*M22*s2 - s3) +s*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5) -3*M22*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) +M12*M22*(-9*M26*sqrts +14*M24*TMath::Power(s, 1.5) +2*s*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5) -M22*(5*TMath::Power(s, 2.5) +3*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5))) +cos(2*Theta)*(TMath::Power(M1, 10)*sqrts -M18*(3*s + M22)*sqrts +(-s + M22)*M24*(sqrts*sminusm22P2 -sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) -M16*(sqrts*(6*s*M22 + 4*M24 - 3*s2) +sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) +M14*(sqrts*(10*s*M24 + 8*M26 + 11*M22*s2 -s3) + s*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5) -3*M22*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)) +M12*M22*(-5*M26*sqrts +2*M24*TMath::Power(s, 1.5) - 4*TMath::Power(s, 3.5) +2*s*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5) +M22*(7*TMath::Power(s, 2.5) -3*sqrtm14m12sm22smm22*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5)))))*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*sintheta)/147456. + (M1*cosphi1*(-gqL4 + gqR4)*(-gL2 + gR2)*(gL2 + gR2)*TMath::Power(Pi, -5)*sminus1*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(-4*sqrts*costhetaP2*(M16 - M14*(s + 3*M22) +M12*(-6*s*M22 + 3*M24 - s2) -TMath::Power(-s + M22, 3))*TMath::Power(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2) - TMath::Power(-s + M12 + M22, 2), -1) + 16*(-s + M12 + M22)*costhetaP2*sqrtm14m12sm22smm22*(TMath::Power(s, 2.5)*sqrtm14m12sm22smm22 -TMath::Power(M12 + M22, 2)*TMath::Power(s*(M14 - 2*M12*(s + M22) +sminusm22P2), 0.5))*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2) + 2*sqrts*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*(TMath::Power(-s + M12 + M22, 2)*(M16 + M14*(-s + 13*M22) +cos(2*Theta)*(-s + TMath::Power(M1 - M2, 2))*(s + M12 - M22)*(-s + TMath::Power(M1 + M2, 2)) -M12*(-22*s*M22 + 13*M24 + s2) -TMath::Power(-s + M22, 3) -8*s*M12*M22*sinthetaP2) +costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)*(5*M16 + M14*(-5*s + M22) +cos(2*Theta)*(-s + TMath::Power(M1 - M2, 2))*(s + M12 - M22)*(-s + TMath::Power(M1 + M2, 2)) -M12*(50*s*M22 + 17*M24 + 5*s2) +(5*s + 11*M22)*sminusm22P2 +8*s*M12*M22*sinthetaP2)))*sintheta)/2.359296e6;



  if ((totval <= 0)||(totval != totval)) totval = 1.e-40;

  //    std::cout << "returnVal_3 = " << totval << std::endl;
  //    totval*=shs;

  return totval;
}

Double_t RooqqZZ_JHU_ZgammaZZ_fast::integratePartonicXS_Dh1Dh2DPh1_4(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool isuubar, bool flipAxis) const{
  const double GeV=1./100.;

  // define hs, h1, h2, phi1, phi2 for the NW angular conventions
  double s = mZZ_c*mZZ_c;
  double M1 = m1_c;
  double M2 = m2_c;
  double hs = hs_c;
  double h1 = h1_c;
  double h2 = h2_c;
  double phi = phi_c;
  double Phi1 = Phi1_c;

  // extra definitions needed
  //    double shs = Sqrt(1-hs*hs); // sin Theta
  //    double sh1 = Sqrt(1-h1*h1); // sin theta1
  //    double sh2 = Sqrt(1-h2*h2); // sin theta2
  //    double hsdb = 1 - 2*shs*shs; // cos 2*Theta
  //    double shsdb = 2*hs*shs; // sin 2*Theta
  //    double h1db = 1 - 2*sh1*sh1; // cos 2*theta1
  //    double h2db = 1 - 2*sh2*sh2; // cos 2*theta2

  // definitions ------------------
  double theta1 = acos(h1);
  double theta2 = acos(h2);
  double Theta = acos(hs);

  // fix to remove compiler warnings
  if (theta1||theta2){}

  if (flipAxis){
    //        hs *= -1.;
    Theta += TMath::Pi();
    Phi1 += TMath::Pi();
    //phi += 0;
  }


  double x = (M1*M1-M2*M2)/s;
  double beta1 = sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x)));
  double beta2 = sqrt(1. - (4.*M2*M2)/(s*(1-x)*(1-x)));
  double MZ = 91.1876*GeV; // mass of the Z
  double wZ = 2.4952*GeV; // width of the Z
  double xW = 0.23119; // sin2thetaW
  double Pi = TMath::Pi();
  double alpha = 1./128.; // EM constant

  double gamma1 = 1./sqrt(1 - beta1*beta1);
  double gamma2 = 1./sqrt(1 - beta2*beta2);

  // fix to remove compiler warnings
  if (gamma1||gamma2){}

  double EE = sqrt(4.*Pi*alpha);
  double el = -EE;
  double eq = (-1./3.)*EE;

  double Tf3 = -1/2.; double Qf = -1.;
  double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
  // conversion   
  gL = gL * sqrt(Pi*alpha/(xW*(1-xW)));
  gR = gR * sqrt(Pi*alpha/(xW*(1-xW)));

  double qTf3, qQf;
  if (isuubar){
    qTf3 = 1/2.; qQf = 2./3.;
  }
  else{
    qTf3 = -1/2.; qQf = -1./3.;
  }
  double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
  gqL = gqL * sqrt(Pi*alpha/(xW*(1-xW)));
  gqR = gqR * sqrt(Pi*alpha/(xW*(1-xW)));

  // end definitions ------------------

  double totval = 0.;
  double gqL4= gqL*gqL*gqL*gqL;
  double gqR4= gqR*gqR*gqR*gqR;
  double gqL3= gqL*gqL*gqL;
  double gqR3= gqR*gqR*gqR;
  double M22 = M2*M2;
  double M23 = M2*M2*M2;
  double M24 = M2*M2*M2*M2;
  double M26 = M2*M2*M2*M2*M2*M2;
  //double M28 = M2*M2*M2*M2*M2*M2*M2*M2;
  double M12 = M1*M1;
  double M13 = M1*M1*M1;
  double M14 = M1*M1*M1*M1;
  double M16 = M1*M1*M1*M1*M1*M1;
  double M18 = M1*M1*M1*M1*M1*M1*M1*M1;
  double MZ2 = MZ*MZ;
  //double MZ4 = MZ*MZ*MZ*MZ;
  double wZ2 = wZ*wZ;

  //double sqrts = TMath::Power(s,0.5);
  double s2 = s*s;
  double s3 = s*s*s;
  double sminus2 = 1./(s*s);
  double sminus1 = 1./s;

  double Piminus4 = 1./(Pi*Pi*Pi*Pi);
  double Piminus6 = 1./(Pi*Pi*Pi*Pi*Pi*Pi);

  double costheta  = cos(Theta);
  double sintheta  = sin(Theta);

  double costhetaP2 = costheta*costheta;
  double costhetaP4 = costheta*costheta*costheta*costheta;
  double sinthetaP2 = sintheta*sintheta;
  double sinthetaP4 = sintheta*sintheta*sintheta*sintheta;

  //double costheta1 = cos(theta1);
  //double costheta2 = cos(theta2);
  //double sintheta1 = sin(theta1);
  //double sintheta2 = sin(theta2);

  //double cosphi1   = cos(Phi1);
  //double cosphiplusphi1 = cos(phi + Phi1);

  double sminusm22P2 = (-s + M22)*(-s + M22);
  double m22minusmz2P2 = (M22 - MZ2)*(M22 - MZ2);
  double m12minusmz2P2 = (M12 - MZ2)*(M12 - MZ2);
  //double sqrtm14m12sm22smm22=TMath::Power(M14 -2*M12*(s + M22) + sminusm22P2,0.5);

  //double oneminuscosthetacostheta1 = (-1 + costheta*costheta1);
  //double oneminuscosthetacostheta2 = (-1 + costheta*costheta2);
  //double onepluscosthetacostheta1 = (1 + costheta*costheta1);
  //double onepluscosthetacostheta2 = (1 + costheta*costheta2);

  double gR2 = gR*gR;
  double gL2 = gL*gL;


  totval += -(cos(phi)*(gqL4 + gqR4)*TMath::Power(gL - gR, 2)*TMath::Power(gL + gR, 2)*M13*M23*Piminus4*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(TMath::Power(-s + M12 + M22, 2)*(-2 + sinthetaP2) +costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)*(2 + sinthetaP2)))/196608. +(el*eq*(gL + gR)*M1*M2*cos(phi)*(gqL3 + gqR3)*TMath::Power(gL - gR, 2)*(-2*M12*M22 + (M12 + M22)*MZ2)*Piminus4*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(TMath::Power(-s + M12 + M22, 2)*(-2 + sinthetaP2) +costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)*(2 + sinthetaP2)))/98304. -(M1*M2*cos(phi)*TMath::Power(el, 2)*TMath::Power(eq, 2)*(TMath::Power(gqL, 2) + TMath::Power(gqR, 2))*TMath::Power(gL - gR, 2)*Piminus4*((M1 - MZ)*(M2 - MZ)*(M1 + MZ)*(M2 + MZ) + MZ2*wZ2)*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(TMath::Power(-s + M12 + M22, 2)*(-2 + sinthetaP2) +costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)*(2 + sinthetaP2)))/98304. +(el*eq*(gL + gR)*(gqL3 + gqR3)*(gL2 + gR2)*(-2 + (TMath::Power(M1, -2) + TMath::Power(M2, -2))*MZ2)*Piminus6*sminus1*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(4*M12*M22*costhetaP4*(2*(3*M14 - 2*M12*M22 + 3*M24)*s2 -6*(M12 + M22)*s3 + 3*TMath::Power(s, 4) -6*s*(M12 + M22)*TMath::Power(M12 - M22, 2) +3*TMath::Power(M12 - M22, 4) +2*TMath::Power(cos(phi), 2)*TMath::Power(M14 - 2*M12*(s + M22) +sminusm22P2, 2)) -4*costhetaP2*(-2*M12*M22*(M18 + 2*M16*(s + 3*M22) -2*M14*(9*s*M22 + 7*M24 + 3*s2) +2*M12*(-9*s*M24 + 3*M26 -7*M22*s2 + s3) +(4*s*M22 + M24 + s2)*sminusm22P2) + (-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(-(s*(M16 + M14*(-2*s + 11*M22) +M12*(-8*s*M22 + 11*M24 + s2) +TMath::Power(-(M2*s) + M23, 2))*sinthetaP2) +4*M12*M22*TMath::Power(cos(phi), 2)*(M14 - 2*s*(M12 + M22) + M24 +s2 + s*(-s + M12 + M22)*sinthetaP2))) + TMath::Power(-s + M12 + M22, 2)*(4*M12*M22*(-8*s*(M12 + M22) - 5*s2 -5*TMath::Power(M12 - M22, 2) +2*TMath::Power(cos(phi), 2)*(M14 - 2*M12*(s + M22) +sminusm22P2 +2*s*(-s + M12 + M22)*sinthetaP2) +(2 + cos(2*phi))*s2*sinthetaP4) -s*(M16 - M14*(2*s + M22) +M12*(-8*s*M22 - M24 + s2) +TMath::Power(-(M2*s) + M23, 2))*TMath::Power(sin(2*Theta), 2))))/442368. -((gqL4 + gqR4)*Piminus6*sminus1*TMath::Power(gL2 + gR2, 2)*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)*(4*M12*M22*costhetaP4*(2*(3*M14 - 2*M12*M22 + 3*M24)*s2 -6*(M12 + M22)*s3 + 3*TMath::Power(s, 4) -6*s*(M12 + M22)*TMath::Power(M12 - M22, 2) +3*TMath::Power(M12 - M22, 4) +2*TMath::Power(cos(phi), 2)*TMath::Power(M14 - 2*M12*(s + M22) +sminusm22P2, 2)) -4*costhetaP2*(-2*M12*M22*(M18 + 2*M16*(s + 3*M22) -2*M14*(9*s*M22 + 7*M24 + 3*s2) +2*M12*(-9*s*M24 + 3*M26 -7*M22*s2 + s3) +(4*s*M22 + M24 + s2)*sminusm22P2) + (-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(-(s*(M16 + M14*(-2*s + 11*M22) +M12*(-8*s*M22 + 11*M24 + s2) +TMath::Power(-(M2*s) + M23, 2))*sinthetaP2) +4*M12*M22*TMath::Power(cos(phi), 2)*(M14 - 2*s*(M12 + M22) + M24 +s2 + s*(-s + M12 + M22)*sinthetaP2))) + TMath::Power(-s + M12 + M22, 2)*(4*M12*M22*(-8*s*(M12 + M22) - 5*s2 -5*TMath::Power(M12 - M22, 2) +2*TMath::Power(cos(phi), 2)*(M14 - 2*M12*(s + M22) +sminusm22P2 +2*s*(-s + M12 + M22)*sinthetaP2) +(2 + cos(2*phi))*s2*sinthetaP4) -s*(M16 - M14*(2*s + M22) +M12*(-8*s*M22 - M24 + s2) +TMath::Power(-(M2*s) + M23, 2))*TMath::Power(sin(2*Theta), 2))))/884736. +(TMath::Power(el, 2)*TMath::Power(eq, 2)*(TMath::Power(gqL, 2) + TMath::Power(gqR, 2))*Piminus6*sminus1*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(-(costhetaP2*(M14 - 2*M12*(s + M22) +sminusm22P2)) + TMath::Power(-s + M12 + M22, 2), -2)*(TMath::Power(gL + gR, 2)*TMath::Power(M1, -2)*TMath::Power(M2, -2)*(2*(M1 - MZ)*(M1 + MZ)*(-M22 + MZ2) -2*MZ2*wZ2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1) +2*(gL2 + gR2)*(-(TMath::Power(M2, -4)*TMath::Power(MZ2*wZ2 +m12minusmz2P2, -1)) -TMath::Power(M1, -4)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1)))*(4*M12*M22*costhetaP4*(2*(3*M14 - 2*M12*M22 + 3*M24)*s2 -6*(M12 + M22)*s3 + 3*TMath::Power(s, 4) -6*s*(M12 + M22)*TMath::Power(M12 - M22, 2) +3*TMath::Power(M12 - M22, 4) +2*TMath::Power(cos(phi), 2)*TMath::Power(M14 - 2*M12*(s + M22) +sminusm22P2, 2)) -4*costhetaP2*(-2*M12*M22*(M18 + 2*M16*(s + 3*M22) -2*M14*(9*s*M22 + 7*M24 + 3*s2) +2*M12*(-9*s*M24 + 3*M26 -7*M22*s2 + s3) +(4*s*M22 + M24 + s2)*sminusm22P2) + (-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(-(s*(M16 + M14*(-2*s + 11*M22) +M12*(-8*s*M22 + 11*M24 + s2) +TMath::Power(-(M2*s) + M23, 2))*sinthetaP2) +4*M12*M22*TMath::Power(cos(phi), 2)*(M14 - 2*s*(M12 + M22) + M24 +s2 + s*(-s + M12 + M22)*sinthetaP2))) + TMath::Power(-s + M12 + M22, 2)*(4*M12*M22*(-8*s*(M12 + M22) - 5*s2 -5*TMath::Power(M12 - M22, 2) +2*TMath::Power(cos(phi), 2)*(M14 - 2*M12*(s + M22) +sminusm22P2 +2*s*(-s + M12 + M22)*sinthetaP2) +(2 + cos(2*phi))*s2*sinthetaP4) -s*(M16 - M14*(2*s + M22) +M12*(-8*s*M22 - M24 + s2) +TMath::Power(-(M2*s) + M23, 2))*TMath::Power(sin(2*Theta), 2))))/884736.;



  if ((totval <= 0)||(totval != totval)) totval = 1.e-40;

  //    std::cout << "returnVal_4 = " << totval << std::endl;
  //    totval*=shs;

  return totval;
}

Double_t RooqqZZ_JHU_ZgammaZZ_fast::integratePartonicXS_Dh1Dh2DphDPh1_5(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool isuubar, bool flipAxis) const{
  const double GeV=1./100.;

  // define hs, h1, h2, phi1, phi2 for the NW angular conventions
  double s = mZZ_c*mZZ_c;
  double M1 = m1_c;
  double M2 = m2_c;
  double hs = hs_c;
  double h1 = h1_c;
  double h2 = h2_c;
  double phi = phi_c;
  double Phi1 = Phi1_c;

  // fix to remove compiler warnings
  if (phi){}

  // extra definitions needed
  //    double shs = Sqrt(1-hs*hs); // sin Theta
  //    double sh1 = Sqrt(1-h1*h1); // sin theta1
  //    double sh2 = Sqrt(1-h2*h2); // sin theta2
  //    double hsdb = 1 - 2*shs*shs; // cos 2*Theta
  //    double shsdb = 2*hs*shs; // sin 2*Theta
  //    double h1db = 1 - 2*sh1*sh1; // cos 2*theta1
  //    double h2db = 1 - 2*sh2*sh2; // cos 2*theta2

  // definitions ------------------
  double theta1 = acos(h1);
  double theta2 = acos(h2);
  double Theta = acos(hs);

  // fix to remove compiler warnings
  if (theta1||theta2){}

  if (flipAxis){
    //        hs *= -1.;
    Theta += TMath::Pi();
    Phi1 += TMath::Pi();
    //phi += 0;
  }

  double x = (M1*M1-M2*M2)/s;
  double beta1 = sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x)));
  double beta2 = sqrt(1. - (4.*M2*M2)/(s*(1-x)*(1-x)));
  double MZ = 91.1876*GeV; // mass of the Z
  double wZ = 2.4952*GeV; // width of the Z
  double xW = 0.23119; // sin2thetaW
  double Pi = TMath::Pi();
  double alpha = 1./128.; // EM constant

  double gamma1 = 1./sqrt(1 - beta1*beta1);
  double gamma2 = 1./sqrt(1 - beta2*beta2);

  // fix to remove comiler warnings
  if (gamma1||gamma2){}

  double EE = sqrt(4.*Pi*alpha);
  double el = -EE;
  double eq = (-1./3.)*EE;

  double Tf3 = -1/2.; double Qf = -1.;
  double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
  // conversion   
  gL = gL * sqrt(Pi*alpha/(xW*(1-xW)));
  gR = gR * sqrt(Pi*alpha/(xW*(1-xW)));

  double qTf3, qQf;
  if (isuubar){
    qTf3 = 1/2.; qQf = 2./3.;
  }
  else{
    qTf3 = -1/2.; qQf = -1./3.;
  }
  double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
  gqL = gqL * sqrt(Pi*alpha/(xW*(1-xW)));
  gqR = gqR * sqrt(Pi*alpha/(xW*(1-xW)));

  // end definitions ------------------


  double totval = 0.;
  double gqL4= gqL*gqL*gqL*gqL;
  double gqR4= gqR*gqR*gqR*gqR;
  double gqL3= gqL*gqL*gqL;
  double gqR3= gqR*gqR*gqR;
  double M22 = M2*M2;
  //double M23 = M2*M2*M2;
  double M24 = M2*M2*M2*M2;
  double M26 = M2*M2*M2*M2*M2*M2;
  //double M28 = M2*M2*M2*M2*M2*M2*M2*M2;
  double M12 = M1*M1;
  //double M13 = M1*M1*M1;
  double M14 = M1*M1*M1*M1;
  double M16 = M1*M1*M1*M1*M1*M1;
  double M18 = M1*M1*M1*M1*M1*M1*M1*M1;
  double MZ2 = MZ*MZ;
  double MZ4 = MZ*MZ*MZ*MZ;
  double wZ2 = wZ*wZ;

  //double sqrts = TMath::Power(s,0.5);
  double s2 = s*s;
  double s3 = s*s*s;
  double sminus2 = 1./(s*s);
  double sminus1 = 1./s;

  //double Piminus4 = 1./(Pi*Pi*Pi*Pi);
  //double Piminus6 = 1./(Pi*Pi*Pi*Pi*Pi*Pi);

  //double costheta  = cos(Theta);
  //double sintheta  = sin(Theta);

  //double costhetaP2 = costheta*costheta;
  //double costhetaP4 = costheta*costheta*costheta*costheta;
  //double sinthetaP2 = sintheta*sintheta;
  //double sinthetaP4 = sintheta*sintheta*sintheta*sintheta;

  //double costheta1 = cos(theta1);
  //double costheta2 = cos(theta2);
  //double sintheta1 = sin(theta1);
  //double sintheta2 = sin(theta2);

  //double cosphi1   = cos(Phi1);
  //double cosphiplusphi1 = cos(phi + Phi1);

  double sminusm22P2 = (-s + M22)*(-s + M22);
  double m22minusmz2P2 = (M22 - MZ2)*(M22 - MZ2);
  double m12minusmz2P2 = (M12 - MZ2)*(M12 - MZ2);
  //double sqrtm14m12sm22smm22=TMath::Power(M14 -2*M12*(s + M22) + sminusm22P2,0.5);

  //double oneminuscosthetacostheta1 = (-1 + costheta*costheta1);
  //double oneminuscosthetacostheta2 = (-1 + costheta*costheta2);
  //double onepluscosthetacostheta1 = (1 + costheta*costheta1);
  //double onepluscosthetacostheta2 = (1 + costheta*costheta2);

  double gR2 = gR*gR;
  double gL2 = gL*gL;


  totval += -((gqL4 + gqR4)*M12*M22*TMath::Power(Pi, -5)*sminus1*TMath::Power(gL2 + gR2, 2)*(-5*M18 + 4*M16*(s + M22) +2*M14*(-50*s*M22 + M24 + s2) +4*M12*(-25*s*M24 + M26 + 7*M22*s2 +s3) - (6*s*M22 + 5*M24 + 5*s2)*sminusm22P2 +(-s + TMath::Power(M1 - M2, 2))*(-s + TMath::Power(M1 + M2, 2))*(cos(4*Theta)*(M14 - 2*M12*(s + M22) +sminusm22P2) +4*cos(2*Theta)*TMath::Power(s + M12 + M22, 2)))*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*TMath::Power(M14 + M12*(-2*s + 6*M22) +sminusm22P2 -cos(2*Theta)*(M14 - 2*M12*(s + M22) +sminusm22P2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/55296. +(el*eq*(gL + gR)*(gqL3 + gqR3)*(gL2 + gR2)*(2*M12*M22 - (M12 + M22)*MZ2)*TMath::Power(Pi, -5)*sminus1*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*(5*M18 - 4*M16*(s + M22) -2*M14*(-50*s*M22 + M24 + s2) -4*M12*(-25*s*M24 + M26 + 7*M22*s2 +s3) + (6*s*M22 + 5*M24 + 5*s2)*sminusm22P2 -4*cos(2*Theta)*(M14 - 2*M12*(s + M22) +sminusm22P2)*TMath::Power(s + M12 + M22, 2) -cos(4*Theta)*TMath::Power(M14 - 2*M12*(s + M22) +sminusm22P2, 2))*TMath::Power(M14 + M12*(-2*s + 6*M22) +sminusm22P2 -cos(2*Theta)*(M14 - 2*M12*(s + M22) +sminusm22P2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/27648. -(TMath::Power(el, 2)*TMath::Power(eq, 2)*(TMath::Power(gqL, 2) + TMath::Power(gqR, 2))*TMath::Power(M1, -2)*TMath::Power(M2, -2)*TMath::Power(Pi, -5)*sminus1*(2*gL*gR*M12*M22*((M1 - MZ)*(M2 - MZ)*(M1 + MZ)*(M2 + MZ) + MZ2*wZ2) +gL2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 + MZ4 +MZ2*wZ2)) +gR2*(M24*MZ2*(MZ2 + wZ2) +M12*M22*MZ2*(-3*M22 + MZ2 + wZ2) +M14*(3*M24 - 3*M22*MZ2 + MZ4 +MZ2*wZ2)))*TMath::Power(1 - 2*(M12 + M22)*sminus1 +sminus2*TMath::Power(M12 - M22, 2), 0.5)*(-5*M18 + 4*M16*(s + M22) +2*M14*(-50*s*M22 + M24 + s2) +4*M12*(-25*s*M24 + M26 + 7*M22*s2 +s3) - (6*s*M22 + 5*M24 + 5*s2)*sminusm22P2 +4*cos(2*Theta)*(M14 - 2*M12*(s + M22) +sminusm22P2)*TMath::Power(s + M12 + M22, 2) +cos(4*Theta)*TMath::Power(M14 - 2*M12*(s + M22) +sminusm22P2, 2))*TMath::Power(M14 + M12*(-2*s + 6*M22) +sminusm22P2 -cos(2*Theta)*(M14 - 2*M12*(s + M22) +sminusm22P2), -2)*TMath::Power(MZ2*wZ2 + m12minusmz2P2, -1)*TMath::Power(MZ2*wZ2 + m22minusmz2P2, -1))/27648.;



  if ((totval <= 0)||(totval != totval)) totval = 1.e-40;

  //    std::cout << "Ms = " << M1 << ", " << M2 << ", " << Sqrt(s) << std::endl;
  //    std::cout << "x = " << x << std::endl;    
  //    std::cout << "betas = " << beta1 << ", " << beta2 << std::endl;
  //    std::cout << "gammas = " << gamma1 << ", " << gamma2 << std::endl;
  //    std::cout << "returnVal_5 = " << totval << std::endl;

  //    totval*=shs;

  return totval;
}
